<template>
	<div>
		<div v-if="!hasPermission('get:university-all')">
			<b-card bg-variant="danger">
				You do not have the permission to view Universities
			</b-card>
		</div>
		<div v-if="hasPermission('get:university-all')">
			<b-card
				no-body
				class="mb-1"
				v-for="u in universities"
				v-bind:key="u.lms_id"
			>
				<b-card-header header-tag="header" class="p-1" role="tab">
					<b-button
						:id="'btnUniversity_' + u.lms_id"
						block
						href="#"
						v-b-toggle="'accord_uni_' + u.lms_id"
						variant="info"
						>{{ u.short_name }}</b-button
					>
					<AdminHelpTooltip
						:target="'btnUniversity_' + u.lms_id"
						permissions="get:university-all"
					/>
				</b-card-header>
				<b-collapse
					:id="'accord_uni_' + u.lms_id"
					accordion="universities"
					role="tabpanel"
				>
					<b-card-body>
						<div class="d-flex justify-content-between">
							<b-card-text class="p-1">{{ u.name }}</b-card-text>
						</div>
						<CourseIdInput
							:value="u.template_lms_id_fall"
							:lms_id="u.lms_id"
							:read_only="false"
							type="university"
							term="fall"
						/>
						<CourseIdInput
							:value="u.template_lms_id_spring"
							:lms_id="u.lms_id"
							:read_only="false"
							type="university"
							term="spring"
						/>
						<CourseIdInput
							:value="u.template_lms_id_summer"
							:lms_id="u.lms_id"
							:read_only="false"
							type="university"
							term="summer"
						/>
						<div
							class="px-5"
							v-if="hasPermission('get:college-all')"
							v-show="colleges_filtered(u.lms_id).length > 0"
						>
							<hr class="mt-3" />
							{{ u.short_name }} Colleges:
							<b-card
								no-body
								class="mb-1"
								v-for="c in colleges_filtered(u.lms_id)"
								v-bind:key="c.lms_id"
							>
								<b-card-header header-tag="header" class="p-1" role="tab">
									<b-button
										:id="'btnCollege_' + c.lms_id"
										block
										href="#"
										v-b-toggle="'accord_col_' + c.lms_id"
										variant="dark"
										>{{ c.name }}</b-button
									>
									<AdminHelpTooltip
										:target="'btnCollege_' + c.lms_id"
										permissions="get:college-all"
									/>
								</b-card-header>
								<b-collapse
									:id="'accord_col_' + c.lms_id"
									:accordion="'colleges_' + c.lms_id"
									role="tabpanel"
								>
									<b-card-body>
										<div class="d-flex justify-content-between">
											<b-card-text class="p-1">{{ c.name }}</b-card-text>
										</div>
										<CourseIdInput
											:value="c.template_lms_id_fall"
											:lms_id="c.lms_id"
											:read_only="false"
											type="college"
											term="fall"
										/>
										<CourseIdInput
											:value="c.template_lms_id_spring"
											:lms_id="c.lms_id"
											:read_only="false"
											type="college"
											term="spring"
										/>
										<CourseIdInput
											:value="c.template_lms_id_summer"
											:lms_id="c.lms_id"
											:read_only="false"
											type="college"
											term="summer"
										/>
										<div
											class="px-5"
											v-if="hasPermission('get:academicUnit-all')"
											v-show="academic_units_filtered(c.lms_id).length > 0"
										>
											<hr class="mt-3" />
											{{ c.name }} Academic Units
											<b-card
												no-body
												class="mb-1"
												v-for="au in academic_units_filtered(c.lms_id)"
												v-bind:key="au.lms_id"
											>
												<b-card-header
													header-tag="header"
													class="p-1"
													role="tab"
												>
													<b-button
														:id="'btnAcademicUnit_' + au.lms_id"
														block
														href="#"
														v-b-toggle="'accord_au_' + au.lms_id"
														variant="light"
														>{{ au.name }}</b-button
													>
													<AdminHelpTooltip
														:target="'btnAcademicUnit_' + au.lms_id"
														permissions="get:academicUnit-all"
													/>
												</b-card-header>
												<b-collapse
													:id="'accord_au_' + au.lms_id"
													:accordion="'acad_unit_' + au.lms_id"
													role="tabpanel"
												>
													<b-card-body>
														<div class="d-flex justify-content-between">
															<b-card-text class="p-1">{{
																au.name
															}}</b-card-text>
														</div>
														<CourseIdInput
															:value="au.template_lms_id_fall"
															:lms_id="au.lms_id"
															:read_only="false"
															type="academicUnit"
															term="fall"
														/>
														<CourseIdInput
															:value="au.template_lms_id_spring"
															:lms_id="au.lms_id"
															:read_only="false"
															type="academicUnit"
															term="spring"
														/>
														<CourseIdInput
															:value="au.template_lms_id_summer"
															:lms_id="au.lms_id"
															:read_only="false"
															type="academicUnit"
															term="summer"
														/>
													</b-card-body>
												</b-collapse>
											</b-card>
										</div>
									</b-card-body>
								</b-collapse>
							</b-card>
						</div>
					</b-card-body>
				</b-collapse>
			</b-card>
		</div>
	</div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
	data() {
		return {};
	},
	computed: {
		...mapGetters({
			colleges: "System/MasterCourses/colleges_all",
			academic_units: "System/MasterCourses/academic_units_all"
		}),
		...mapGetters({universities: "MasterCourseSelector/universities", hasPermission:"Navbar/hasPermission"})
	},
	methods: {
		...mapActions({
			get_universities: "MasterCourseSelector/get_universities",
			get_colleges: "System/MasterCourses/get_colleges_all",
			get_academic_units: "System/MasterCourses/get_academic_units_all"
		}),
		colleges_filtered(university_lms_id) {
			if (this.colleges === undefined) {
				return [];
			}

			return this.colleges.filter(function(c) {
				return c.parent === university_lms_id;
			});
		},
		academic_units_filtered(college_lms_id) {
			if (this.academic_units === undefined) {
				return [];
			}

			return this.academic_units.filter(function(au) {
				return au.parent === college_lms_id;
			});
		}
	},
	mounted() {
		if (this.hasPermission("get:university-all")) {
			this.get_universities();
		}

		if (this.hasPermission("get:college-all")) {
			this.get_colleges();
		}

		if (this.hasPermission("get:academicUnit-all")) {
			this.get_academic_units();
		}
	}
};
</script>
